<#ibizinclude>
../@MACRO/CONTROL/CONTROL_HEADER.tsx.ftl
</#ibizinclude>

    /**
     * 获取多项数据
     *
     * @returns {any[]}
     * @memberof ${srfclassname('${ctrl.codeName}')}
     */
    public getDatas(): any[] {
        return this.items;
    }

    /**
     * 获取单项树
     *
     * @returns {*}
     * @memberof ${srfclassname('${ctrl.codeName}')}
     */
    public getData(): any {
        return this.selection;
    }

    /**
     * 加载行为
     *
     * @type {string}
     * @memberof ${srfclassname('${ctrl.codeName}')}
     */
    @Prop() public loadAction?: string;

    /**
     * url
     *
     * @private
     * @type {string}
     * @memberof ${srfclassname('${ctrl.codeName}')}
     */
    private url: string = '<#ibizinclude>../@MACRO/CONTROL/URL.tsx.ftl</#ibizinclude>';

    /**
     * 数据选中项
     *
     * @type {*}
     * @memberof ${srfclassname('${ctrl.codeName}')}
     */
    public selection: any = {};

    /**
     * 关系栏数据项
     *
     * @type {any[]}
     * @memberof ${srfclassname('${ctrl.codeName}')}
     */
    public items: any[] = [];

    /**
     * 默认打开项
     *
     * @type {string[]}
     * @memberof ${srfclassname('${ctrl.codeName}')}
     */
    public defaultOpeneds: string[] = [];

    /**
     * 父数据
     *
     * @private
     * @type {*}
     * @memberof ${srfclassname('${ctrl.codeName}')}
     */
    private parentData: any = {};

    /**
     * 宽度
     *
     * @type {number}
     * @memberof ${srfclassname('${ctrl.codeName}')}
     */
    public width: number = <#if ctrl.getWidth() gt 240><#else>240</#if>;

    /**
     * 生命周期
     *
     * @memberof ${srfclassname('${ctrl.codeName}')}
     */
    public created(): void {
        if (this.viewState) {
            this.viewStateEvent = this.viewState.subscribe(({ tag, action, data }) => {
                if (!Object.is(tag, this.name)) {
                    return;
                }
                if (Object.is('load', action)) {
                    if (data.srfkey && !Object.is(data.srfkey, '')) {
                        Object.assign(this.parentData, { srfparentkey: data.srfkey });
                    }
                    this.load(data);
                }
                if (Object.is('state', action)) {
                    if (data.srfkey && !Object.is(data.srfkey, '')) {
                        Object.assign(this.parentData, { srfparentkey: data.srfkey });
                    }
                    const state = !this.parentData.srfparentkey || (this.parentData.srfparentkey && Object.is(this.parentData.srfparentkey, '')) ? true : false;
                    this.setItemDisabled(this.items, state);
                }
            });
        }
    }

    /**
     * vue 生命周期
     *
     * @memberof ${srfclassname('${ctrl.codeName}')}
     */
    public destroyed() {
        if (this.viewStateEvent) {
            this.viewStateEvent.unsubscribe();
        }
        <#if destroyed_block??>
        ${destroyed_block}
        </#if>
    }

    /**
     * 获取关系项
     *
     * @private
     * @param {*} [arg={}]
     * @returns {*}
     * @memberof ${srfclassname('${ctrl.codeName}')}
     */
    private getDRBarItem(arg: any = {}): any {
        let expmode = arg.nodetype.toUpperCase();
        if (!expmode) {
            expmode = '';
        }
        <#list ctrl.getPSAppViewRefs() as item>
        <#if (item.getName()?index_of("DRITEM:")==0)>
        <#assign refview = item.getRefPSAppView()>
        if (Object.is(expmode, '${item.getName()?substring(7)}')) {
            return {  
                viewname: '${srffilepath2(refview.codeName)}', 
                parentdatajo: <#if item.getParentDataJO()??>${item.getParentDataJO()}<#else>{},</#if>
			};
        }
        </#if>
        </#list>
        return undefined;
    }

    /**
     * 加载关系栏数据
     *
     * @param {*} [arg={}]
     * @memberof ${srfclassname('${ctrl.codeName}')}
     */
    public load(arg: any = {}): void {
        const params: any = {};
        Object.assign(params, arg);
        const get: Promise<any> = this.$http.get(this.url + this.loadAction, params);
        get.then((response: any) => {
            if (response && response.status === 200) {
                const data = response.data;
                this.dataProcess(data.items);
                this.items = [...data.items];
                this.$emit('load', this.items);
                if (this.items.length > 0) {
                    this.onSelect(this.items[0].id)
                }
            }
        }).catch((response: any) => {
            if (response && response.status === 401) {
                return;
            }
            this.$Notice.error({ title: '错误', desc: response.info });
        });
    }

    /**
     * 处理数据
     *
     * @private
     * @param {any[]} items
     * @memberof ${srfclassname('${ctrl.codeName}')}
     */
    private dataProcess(items: any[]): void {
        items.forEach((_item: any) => {
            if (_item.expanded) {
                this.defaultOpeneds.push(_item.id);
            }

            _item.disabled = false;
            if (_item.items && Array.isArray(_item.items) && _item.items.length > 0) {
                this.dataProcess(_item.items);
            }
        });
    }

    /**
     * 获取子项
     *
     * @param {any[]} items
     * @param {string} drviewid
     * @returns {*}
     * @memberof ${srfclassname('${ctrl.codeName}')}
     */
    public getItem(items: any[], id: string): any {
        const item: any = {};
        items.some((_item: any) => {
            if (Object.is(_item.id, id)) {
                Object.assign(item, _item);
                return true;
            }
            if (_item.items && _item.items.length > 0) {
                const subItem = this.getItem(_item.items, id);
                if (Object.keys(subItem).length > 0) {
                    Object.assign(item, subItem);
                    return true;
                }
            }
            return false;
        });
        return item;
    }

    /**
     * 节点选中
     *
     * @param {*} $event
     * @memberof ${srfclassname('${ctrl.codeName}')}
     */
    public onSelect($event: any): void {
        const item = this.getItem(this.items, $event);
        if (Object.is(item.id, this.selection.id)) {
            return;
        }

        this.$emit('selectionchange', [item]);

        const refview = this.getDRBarItem({ nodetype: item.drviewid });
        this.selection = {};
        const params: any = { ...JSON.parse(JSON.stringify(this.parentData)) };
        if (refview && refview.parentdatajo) {
            Object.assign(params, refview.parentdatajo);
            Object.assign(this.selection, { view: { viewname: refview.viewname }, data: params });
        }
        Object.assign(this.selection, item);
    }

    /**
     * 子节点打开
     *
     * @param {*} $event
     * @memberof ${srfclassname('${ctrl.codeName}')}
     */
    public onOpen($event: any): void {
        const item = this.getItem(this.items, $event);
        if (Object.is(item.id, this.selection.id)) {
            return;
        }
        this.selection = {};
        Object.assign(this.selection, item);
        if (Object.is(item.id, 'form') || (item.viewname && !Object.is(item.viewname, ''))) {
            this.$emit('selectionchange', [this.selection]);
        }
    }

    /**
     * 子节点关闭
     *
     * @param {*} $event
     * @memberof ${srfclassname('${ctrl.codeName}')}
     */
    public onClose($event: any): void {
        const item = this.getItem(this.items, $event);
        if (Object.is(item.id, this.selection.id)) {
            return;
        }
        this.selection = {};
        Object.assign(this.selection, item);
        if (Object.is(item.id, 'form') || (item.viewname && !Object.is(item.viewname, ''))) {
            this.$emit('selectionchange', [this.selection]);
        }
    }

    /**
     * 设置关系项状态
     *
     * @param {any[]} items
     * @param {boolean} state
     * @memberof ${srfclassname('${ctrl.codeName}')}
     */
    public setItemDisabled(items: any[], state: boolean) {
        items.forEach((item: any) => {
            if (!Object.is(item.id, 'form')) {
                item.disabled = state;
            }
            if (item.items && Array.isArray(item.items)) {
                this.setItemDisabled(item.items, state);
            }
        });
    }

    /**
     * 绘制图标
     *
     * @param {*} item
     * @returns
     * @memberof ${srfclassname('${ctrl.codeName}')}
     */
    public renderIcon(item: any) {
        return (
            item.icon && !Object.is(item.icon, '') ?
                <img src={item.icon} class='app-menu-icon' />
                :
                item.iconcls && !Object.is(item.iconcls, '') ?
                    <i class={item.iconcls + ' app-menu-icon'}></i>
                    : ''
        );
    }

    /**
     * 关系项
     *
     * @param {*} [item={}]
     * @returns
     * @memberof ${srfclassname('${ctrl.codeName}')}
     */
    public renderItem(item: any = {}) {
        return (
            <el-menu-item index={item.id} disabled={item.disabled}>
                {this.renderIcon(item)}
                <span slot='title'>{item.text}</span>
            </el-menu-item>
        );
    }

    /**
     * 绘制关系子菜单项
     *
     * @param {*} item
     * @returns
     * @memberof ${srfclassname('${ctrl.codeName}')}
     */
    public renderSubMenu(item: any) {
        return (
            <el-submenu index={item.id} disabled={item.disabled}>
                <template slot='title'>
                    {this.renderIcon(item)}
                    <span>{item.text}</span>
                </template>
                {
                    item.items.map((_item: any) => {
                        if (_item.items && Array.isArray(_item.items) && _item.items.length > 0) {
                            return this.renderSubMenu(_item);
                        } else {
                            return this.renderItem(_item);
                        }
                    })
                }
            </el-submenu>
        );
    }

    /**
     * 内容绘制
     *
     * @returns
     * @memberof ${srfclassname('${ctrl.codeName}')}
     */
    public render() {
        return (
            <layout class='app-dr-bar'>
                <sider width={this.width}>
                    <el-menu
                        default-openeds={this.defaultOpeneds}
                        on-select={($event: any) => this.onSelect($event)}
                        on-open={($event: any) => this.onOpen($event)}
                        on-close={($event: any) => this.onClose($event)}>
                        {
                            this.items.map((item: any) => {
                                if (item.items && Array.isArray(item.items) && item.items.length > 0) {
                                    return this.renderSubMenu(item);
                                } else {
                                    return this.renderItem(item);
                                }
                            })
                        }
                    </el-menu>
                </sider>
                <content <#noparse>style={{ width: `calc(100% - ${this.width + 1}px)` }}</#noparse>>
                    <div class='main-data' v-show={Object.is(this.selection.id, 'form')}>
                        {this.$slots.default}
                    </div>
                    {
                        (
                            !Object.is(this.selection.id, 'form') &&
                            this.selection.view &&
                            !Object.is(this.selection.view.viewname, '')
                        )  ?
                            this.$createElement(this.selection.view.viewname, {
                                class: {
                                    viewcontainer2: true,
                                },
                                props: {
                                    viewdata: JSON.stringify({ srfparentdata: this.selection.data }),
                                },
                                key: this.$util.createUUID(),
                            })
                            : ''
                    }
                </content>
            </layout>
        );
    }


<#ibizinclude>
../@MACRO/CONTROL/CONTROL_BOTTOM.tsx.ftl
</#ibizinclude>